#include "SendFileThread.h"
#include "MySyncObject.h"		// CMySyncObjectg
#include "SendRecvThread.h"		// CSendRecvThreadg


CSendFileThread::CSendFileThread(CSendRecvThread *pCSendRecvThread, LPSTR pszFileName)
{
	// RXgN^̈o
	m_pCSendRecvThread = pCSendRecvThread;
	m_pszFileName = (LPSTR)calloc(strlen(pszFileName) + 1, sizeof(char));
	DISABLE_C4996
	strcpy(m_pszFileName, pszFileName);
	ENABLE_C4996

	// ϐ̏
	m_fIamZombie = FALSE;
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
}


CSendFileThread::~CSendFileThread()
{
	if(m_pCMySyncObject != NULL)
		m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
	SAFE_FREE(m_pszFileName)
}


UINT CSendFileThread::DoWork()
{
	int		fdSrcFile;		// Mt@CfBXNv^
	struct stat statInfo;	// t@C̏̂߂̕ϐ
	long	lFileLength;

	//----------------------------------------------------
	// @t@COpenāAMJnvpPbg𑗐M
	// t@COpen
	DISABLE_C4996
	fdSrcFile = _open(m_pszFileName, _O_RDONLY | _O_BINARY);
	ENABLE_C4996
	if (fdSrcFile == -1)
		goto L_END;
	// t@C̏擾(t@CTCY)
	if (fstat(fdSrcFile, &statInfo) != 0)
		goto L_END;
	lFileLength = statInfo.st_size;

	// t@C, t@C̑M
	if (SendSendFileStartPacket(m_pszFileName, lFileLength) == FALSE)
		goto L_END;
	//----------------------------------------------------
	// Aŉ҂悤ɂ
	//----------------------------------------------------
	// BCt@CǂݍŃt@CM/t@CMpPbg𑗐M
	// ̊֐ŃG[NƂ́AfR}h𑗂悤ɂ̂ǂł傤
	if (SendSendFilePacket(fdSrcFile, lFileLength) == FALSE)
		goto L_END;
	//----------------------------------------------------
	// Dŉ҂悤ɂ
	//----------------------------------------------------

L_END:
	// t@Cclose
	if (fdSrcFile != -1)
		_close(fdSrcFile);
	m_pCMySyncObject->Lock();
	m_fIamZombie = TRUE;		// t@CM/sŃ]r
	m_pCMySyncObject->UnLock();
	return(0);					// /sŕԒlς̂ł傤
}

//----------------------------------------------
// function
//		@t@CMJnR}h̑M
// parameter
//		LPSTR	pszFileName	[in]t@C
//		int		iFileLength	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendSendFileStartPacket(LPSTR pszFileName, int iFileLength)
{
	BOOL		fRet = FALSE;
	SendFileStartReqRec	*pSendFileStartReq = NULL;
	int			iPacketSize;
	int			iSize;
	LPBYTE		pbDest = NULL;

	// ʃwb_Ƀf[^i[
	iPacketSize = sizeof(SendFileStartReqRec);
	pSendFileStartReq = (SendFileStartReqRec *)calloc(iPacketSize, sizeof(BYTE));
	memcpy(pSendFileStartReq->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
	pSendFileStartReq->header.wCommand = htons(CMD_SEND_FILE_START_REQ);
	pSendFileStartReq->header.wDataLen = htons(sizeof(FileInfoRec));

	Locate(1, 8, 2);
	fprintf(stderr, "t@CM %s %d", pszFileName, iFileLength);
	// f[^Ƀf[^i[(t@CTCYAt@C)
	// t@CΉ̂߂UTF-8ɕύXđM
	iSize = 0;
	pbDest = NULL;
	ConvSJistoUtf8((LPBYTE)pszFileName, NULL, &iSize);
	pbDest = (LPBYTE)calloc(iSize, sizeof(BYTE));
	ConvSJistoUtf8((LPBYTE)pszFileName, pbDest, &iSize);

	memcpy(pSendFileStartReq->FileInfo.szFileName, pbDest, iSize);
	DISABLE_C4996
	sprintf(pSendFileStartReq->FileInfo.szFileSize, "%d", iFileLength);
	ENABLE_C4996

	// t@CMJnvpPbg̑M
	fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileStartReq, iPacketSize);

	SAFE_FREE(pbDest)
	SAFE_FREE(pSendFileStartReq);
	return(fRet);
}

#define	READ_SIZE	(1024 * 10)			// t@C̓ǂݍݒP(KobƓǂ݂܂)
//----------------------------------------------
// function
//		t@Cǂݍ݂Ȃt@CMR}h̑M
// parameter
//		int		fd			[in]t@CfBXNv^
//		int		iFileLength	[in]t@C
// retun
//		TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::SendSendFilePacket(int fd, int iFileLength)
{
	BOOL			fRet = FALSE, fEnd = FALSE;
	LPBYTE			pbData = NULL;
	int				iReadSize, iTotalSize = 0;
	SendFileIngRec	*pSendFileIng = NULL;
	int				iPacketSize, iWaitCount = 0;

	pbData = (LPBYTE)calloc(READ_SIZE, sizeof(BYTE));
	while (!m_fStopFlag)
	{
		_lseek(fd, iTotalSize, SEEK_SET);
		iReadSize = _read(fd, pbData, READ_SIZE);
		iPacketSize = sizeof(HeaderRec) + sizeof(SendFileStatRec) + iReadSize;
		pSendFileIng = (SendFileIngRec *)calloc(iPacketSize, sizeof(BYTE));

		// ʃwb_Ƀf[^i[
		memcpy(pSendFileIng->header.bMagicData, MAGIC_STRING, strlen(MAGIC_STRING));
		pSendFileIng->header.wDataLen = htons((WORD)sizeof(SendFileStatRec) + iReadSize);
		// f[^Ƀf[^i[
		DISABLE_C4996
		sprintf(pSendFileIng->Stat.szOffset, "%d", iTotalSize);	// ǂݍ݈ʒu
		sprintf(pSendFileIng->Stat.szSize, "%d", iReadSize);	// ǂݍ񂾃f[^
		ENABLE_C4996
		if (iReadSize > 0)			// t@C̓r𑗐M
		{
			Locate(1, 8, 1);
			fprintf(stderr, "t@CM %d %d %d\n", iTotalSize, iReadSize, iFileLength);
			// ʃwb_Ƀf[^i[
			pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_ING);
			// f[^Ƀf[^i[
			memcpy(pSendFileIng->bData, pbData, iReadSize);
		}
		else						// t@C̍Ō܂œǂ񂾂̂Ŋ𑗐M
		{
			Locate(1, 9, 1);
			fprintf(stderr, "t@CM %d %d\n", iTotalSize, iReadSize);
			// ʃwb_Ƀf[^i[
			pSendFileIng->header.wCommand = htons(CMD_SEND_FILE_END_REQ);
			fEnd = TRUE;				// t@CM
		}
		// pPbgŜ𑗐Mobt@ɏ
		fRet = m_pCSendRecvThread->SetSendData((char *)pSendFileIng, iPacketSize);
		SAFE_FREE(pSendFileIng)
		if (fRet == TRUE)				// pPbg߂
		{
			if (fEnd == TRUE)			// Ō܂őM̂ŏI
				break;
			iTotalSize += iReadSize;	// pPbg߂̂œǂݍ݃|C^XV
		}
		else							// ߂Ȃ̂œǂݍ݃|C^͂̂܂
		{
			Locate(1, 10, 0);
			fprintf(stderr, "Mobt@̋󂫑҂(%d)\n", ++iWaitCount);	// Mobt@ɏȂ̂łƑ҂
			Sleep(100);									// READ_SIZE𑗐M̂Ɋ|鎞Ԓx҂̂ǂł傤
		}
	}
	SAFE_FREE(pbData)
	return(fRet);
}


//----------------------------------------------
// function
//    ̃Xbh̓]rԂ
//	  ʃXbhQƂ
// parameter
//    Ȃ
// return
//	  TRUE/FALSE
//----------------------------------------------
BOOL CSendFileThread::IsZombie()
{
	BOOL	fRet;

	m_pCMySyncObject->Lock();
	fRet = m_fIamZombie;
	m_pCMySyncObject->UnLock();
	return(fRet);
}

